// Calc chips used in After Burner and Galaxy Force hardware
struct CalcChip { unsigned short Reg0[4],Reg4[8],Reg8[4]; };
extern struct CalcChip Calc[3]; // in calc.cpp

int CalcScan();

// (include the Mult/Div/Compare math functions)
#include "calcfn.h"

static INLINE unsigned short CalcRead(int n,unsigned int a)
{
  struct CalcChip *pCalc; unsigned char b;
  pCalc=Calc+n; b=(unsigned char)(a>>12); b&=0xc;
  if (b==0x0) { CalcMult0(pCalc->Reg0); return pCalc->Reg0[(a>>1)&3]; }
  if (b==0x4) {
    unsigned short r;
    r=pCalc->Reg4[(a&0xe)>>1];
    return r;
  }
  if (b==0x8) { CalcDo8(pCalc->Reg8); return pCalc->Reg8[(a>>1)&3]; }
  
  return 0;
}

static INLINE void CalcWrite(int n,unsigned int a,unsigned short d)
{
  struct CalcChip *pCalc; unsigned char b;
  pCalc=Calc+n; b=(unsigned char)(a>>12); b&=0xc;

  if (b==0x0) { pCalc->Reg0[(a>>1)&3]=d; return; }

  if (b==0x4)
  {
    a&=0xe; pCalc->Reg4[a>>1]=d;
    if (a<0xc) CalcDiv4(pCalc->Reg4); else CalcDis4(pCalc->Reg4);
    return;
  }

  if (b==0x8) { pCalc->Reg8[(a>>1)&3]=d; return; }
}

// Byte accesses (much more rare)
static INLINE unsigned char CalcReadByte(int n,unsigned int a)
{
  unsigned short r;
  r=CalcRead(n,a&(~1));
  if (a&1) return (unsigned char)(r&0xff);
  return (unsigned char)(r>>8);
}
