#include "burnint.h"

// CPS Scroll (Background Layers)

// Base = 0x4000 long tile map
// sx=Scroll X value, sy=Scroll Y value,

int CpsScr1Draw(unsigned char *Base,int sx,int sy)
{
  int x,y;
  int ix,iy;
  int nKnowBlank=-1; // The tile we know is blank

  ix=(sx>>3)+1; iy=(sy>>3)+1;
  sx&=7; sy&=7; sx=8-sx; sy=8-sy;

  for (y=-1; y<28; y++)
  {
    for (x=-1; x<48; x++)
    {
      int t,a; int nRet;
      unsigned short *pst;
      int fx,fy,p;
      fx=ix+x; fy=iy+y; // fx/fy= 0 to 63
      
      // Find tile address
      p=((fy&0x20)<<8) | ((fx&0x3f)<<7) | ((fy&0x1f)<<2);
      p&=0x3fff;
      pst=(unsigned short *)(Base + p);

      t=pst[0];
      t<<=6; // Get real tile address
      
      t+=nCpsGfxScroll[1]; // add on offset to scroll tiles

      if (t==nKnowBlank) continue; // Don't draw: we know it's blank

      a=pst[1];

      CpstSetPal(0x20 | (a&0x1f));

      // Don't need to clip except around the border
      if (x<0 || x>=48-1 || y<0 || y>=28-1)
        nCpstType=CTT_8X8 | CTT_CARE;
      else
        nCpstType=CTT_8X8;

      nCpstX=sx+(x<<3); nCpstY=sy+(y<<3);
      nCpstTile=t; nCpstFlip=(a>>5)&3;

      nRet=CpstOne();  if (nRet) nKnowBlank=t;

    }
  }

  return 0;
}

int CpsScr3Draw(unsigned char *Base,int sx,int sy)
{
  int x,y;
  int ix,iy;
  int nKnowBlank=-1; // The tile we know is blank
  ix=(sx>>5)+1; iy=(sy>>5)+1;
  sx&=31; sy&=31; sx=32-sx; sy=32-sy;

  for (y=-1; y<7; y++)
  {
    for (x=-1; x<12; x++)
    {
      int t,a; int nRet;
      unsigned short *pst;
      int fx,fy,p;
      fx=ix+x; fy=iy+y; // fx/fy= 0 to 63
      
      // Find tile address
      p=((fy&0x38)<<8) | ((fx&0x3f)<<5) | ((fy&0x07)<<2);
      p&=0x3fff;
      pst=(unsigned short *)(Base + p);

      // &0x3fff because of capcom screen in X-Men
      t=pst[0]&0x3fff;
 
      t<<=9; // Get real tile address
      t+=nCpsGfxScroll[3]; // add on offset to scroll tiles

      if (t==nKnowBlank) continue; // Don't draw: we know it's blank

      a=pst[1];

      CpstSetPal(0x60 | (a&0x1f));

      // Don't need to clip except around the border
      if (x<0 || x>=12-1 || y<0 || y>=7-1)
        nCpstType=CTT_32X32 | CTT_CARE;
      else
        nCpstType=CTT_32X32;

      nCpstX=sx+(x<<5); nCpstY=sy+(y<<5);
      nCpstTile=t; nCpstFlip=(a>>5)&3;

      nRet=CpstOne();  if (nRet) nKnowBlank=t;
    }
  }

  return 0;
}
