#include "burnint.h"
// Galaxy Force HW - line sprites

// GalLineSrc = pointer to cpu M 188000 usually
unsigned char *GalLineSrc=NULL; // Original line sprite table

unsigned char *GalLineData=NULL; // Line Sprite bitmap data
int nGalLineDataLen=0; // Length of above

int GalLineDrawSprite(int i,unsigned char *ps)
{
  int nPal;
  (void)i;

  memset(&bss,0,sizeof(bss));
  bss.nIncX=bss.nIncY=0x200;

  bss.nTop=ps[0]; bss.nHeight=ps[1]-ps[0];
  
  bss.nLeft=(ps[3]<<8)|ps[2]; bss.nLeft&=0x1ff; bss.nLeft-=0xb8;
  bss.nWidth=ps[4]<<2;
  bss.nClipWidth=bss.nWidth;
  
  bss.nBase=(ps[7]<<9) | (ps[6]<<1);

  if (ps[5]&1)
  {
    bss.nBase+=2;
    bss.bFlipX=1;
  }
  else
  {
    bss.nBase+=bss.nWidth>>1;
  }

  bss.nBase&=0x1ffff;
  bss.nBase|=(ps[9]&3)<<17; // Doing it this way allows some wraparound within the bank

  nPal=0x80+(ps[8]&0x7f);
  
  bss.pPal=BsysPal+(nPal<<4);

  bss.nTrans=0x0001; //normal transparent mask
  BsysSprDraw();
  return 0;
}

int GalLineDraw()
{
  int i=0; unsigned char *ps;
  // Setup up the BsysSpr for the Line sprites:
  BsysSprData=GalLineData; nBsysSprDataLen=nGalLineDataLen;
  for (i=0,ps=GalLineSrc; i<0x80; i++,ps+=16)
  {
    if (ps[5]&0x80) break; // end of list
    if (ps[5]&0x40) continue; // skip sprite
    GalLineDrawSprite(i,ps);
  }
  BsysSprData=NULL; nBsysSprDataLen=0;

  return 0;
}
