#include "burnint.h"
// Galaxy Force HW - sprites

// GalSprSrc = pointer to cpu X 180000 usually
unsigned char *GalSprSrc=NULL; // Original sprite table

unsigned char *GalSprData=NULL; // Normal Sprite bitmap data
int nGalSprDataLen=0; // Length of above

static INLINE int DrawSprite(unsigned char *ps)
{
  int nPalBase;
  // Find bitmap data
  bss.nBase=((ps[5]&0xf0)<<15)|(ps[7]<<11)|(ps[6]<<3);
  if (ps[3]&0x10) bss.nBase|=0x800000; // Rail chase

  bss.nWidth=ps[12]<<4;

  if (ps[12]&0x80) bss.nWidth=0x1000-bss.nWidth;
  bss.nClipWidth=bss.nWidth;

  bss.nLeft=((ps[3]<<8)|ps[2])&0xfff;
  bss.nLeft-=0x660;
  
  bss.nTop=((ps[5]<<8)|ps[4])&0xfff;
  bss.nTop-=0x630;

  if ((GalGame&0xf0)==0x10) bss.nTop-=0x60; // GF
  if ((GalGame&0xf0)==0x30) bss.nTop-=0x60; // Rail chase

  bss.nHeight=((ps[9]<<8)|ps[8])&0x3ff;

  if ((GalGame&0xf0)==0x40)
  {
    // G-Loc
    bss.nTop-=0x060;
  }

  bss.nIncX=((ps[11]<<8)|ps[10])&0x3ff;
  bss.nIncY=bss.nIncX;

  bss.bDrawToLeft=(ps[11]&0x10)==0;
  bss.bFlipX=0;     if ((ps[11]&0x20)==0) { bss.nBase+=8-(bss.nWidth>>1); bss.bFlipX=1; }
  bss.bDrawToTop=0; if ((ps[11]&0x40)==0) { bss.bDrawToTop=1; bss.nHeight--; }

  if (ps[12]&0x80) bss.nIncY=-bss.nIncY;

  // Get the palette base (0x200 size)
  nPalBase=0x1000;
  nPalBase|=(ps[13]&0x30)<<6;
  nPalBase|=(ps[13]&0x40)<<3;

  // Lookup the actual palette colors from the table at the start of GalSprSrc
  {
    static unsigned int CustPal[16]; unsigned int *pc;
    int i=0; int nLookup; unsigned short *pt;
    pc=CustPal;
    nLookup=(ps[1]<<8)|ps[0];

    nLookup<<=5; nLookup&=0xffe0;
    pt=(unsigned short *)(GalSprSrc+nLookup);

    bss.nTrans=0;
    for (i=0;i<16; i++,pc++,pt++ )
    {
      int t; t=*pt;
      bss.nTrans>>=1;
      if (t==0x1ff)
      {
        bss.nTrans|=0x8000; // transparent
      }
      else
      {
        *pc=BsysPal[(nPalBase+t)&(nBsysPalLen-1)]; // Lookup the color to use in the custom palette
      }
    }
    bss.pPal=CustPal; // Use our custom Galaxy Force palette
  }

  BsysSprDraw();
  return 0;
}

int GalSprDraw()
{
  int i=0;
  int nNext=0; // Next sprite to process

  // Setup up the BsysSpr for the normal sprites:
  BsysSprData=GalSprData; nBsysSprDataLen=nGalSprDataLen;

  nNext=0; // Start at the base of the list

  for (i=0; i<0x200; i++)
  {
    unsigned char *ps;
    ps=GalSprSrc+((nNext<<4)&0xfff0);

    if (ps[1]&0x80) break; // end of list
    DrawSprite(ps);
    nNext=(ps[15]<<8)|ps[14]; // Find next sprite
  }
  BsysSprData=NULL; nBsysSprDataLen=0;

  return 0;
}
