// System 16 ---------------------------------------------
// sys.cpp
extern unsigned int *BsysPal; // Pointer to high-color palette (output format)
extern unsigned int nBsysPalLen; // number of colors, must be a power of two
int BsysLoadCode(unsigned char *Rom,int nStart,int nCount);
int BsysLoadTiles(unsigned char *Tile,int nStart);
int BsysZeroSprites(unsigned char *Spr,int nLen);

// sys_pal.cpp
extern unsigned char *BsysPalSrc; // Pointer to input palette
int BsysPalInit();
int BsysPalExit();
int BsysPalUpdate();
void BsysPalWriteByte(unsigned int a,unsigned char d);
void BsysPalWriteWord(unsigned int a,unsigned short d);

// sys_tile.cpp
extern unsigned char *BsysTileData; // Pointer to tile bitmap data
extern int nBsysTileDataLen; // Length of data    (must be power of 2)
extern int nBsysTilePalBase; // Palette Base
int BsysTileOne(unsigned char *Dest,int nTile,int nPal);
int BsysTilePage(int nPage,int nTilePage,unsigned char *RamTx);

// sys_spr.cpp
struct BsysSprite
{
  int nLeft,nTop;   // Coords to start drawing from (on the screen)
  int nHeight;      // Height of the sprite (in pixels on the screen)
  int nWidth;       // Width of the sprite  (in pixels in the data)
  int nClipWidth;   // Clip to this width though
  unsigned int *pPal;// Pointer to highpal palette
  unsigned short nTrans; // Transparent data (0x0001 = color 0 trasnparent)
  int nBase;        // Base of graphics in the rom data
  int nIncX;        // Amount to increase x and y by (in the data) for
  int nIncY;        //   each screen unit (fixed point 23.9)
  unsigned char bFlipX; // Flip left to right
  unsigned char bDrawToLeft,bDrawToTop;  // Draw right to left/Draw bottom to top
};

extern unsigned char *BsysSprData; // Sprite bitmap data
extern int nBsysSprDataLen; // Length of above
extern struct BsysSprite bss; // Sprite to draw
int BsysSprDraw();

// gr_out.cpp
extern unsigned char *GrOutRam; // Ground ram length 0x1000 bytes
extern unsigned char *GrOutFlag; // Flag ram length 2 bytes
int GrOutDraw();

// pcm.cpp
extern int nPcmRate; // sample rate to render at
extern unsigned char *PcmRom; // Pointer to the Pcm banks
extern int nPcmBankCount; // Count of the number of banks
extern int nPcmBankSize; // Bank length is 1<<nPcmBankSize bytes
int PcmInit();
int PcmExit();
int PcmScan();
int PcmUpdate(short *Dest,int nLen); // Add nLen*2 16-bit samples (stereo interleved) into Dest
extern int (*PcmGetBank) (int nReg86);
unsigned char PcmRead(unsigned short a);
void PcmWrite(unsigned short a,unsigned char d);

// After Burner ----------------------------------
// d_aft2.cpp
int Aft2InputInfo(struct BurnInputInfo *pii,unsigned int i);
// aft_run.cpp
extern unsigned char AftGame;
extern unsigned char AftButton[10];
extern unsigned char AftInput[6];
extern unsigned char AftReset;
int AftInit();
int AftExit();
int AftFrame();
int AftScan(int nAction,int *pnMin);
// aft_spr.cpp
extern unsigned char *AftSprSrc; // Original sprite table
int AftSprDraw();
// aft_z80.cpp
extern unsigned char *AftZ80;
extern int nAftFmTimer; // The z80 cycle count when FM timer A will carry out
extern unsigned char nAftSoundCode; // The sound code to pass to the z80 program
int AftZScan(int nAction);
int AftZInit();
int AftZExit();
// aft_snd.cpp
extern int bAftSoundOkay; // 1 if the module is initted okay
int AftSoundInit();
int AftSoundExit();
int AftSoundFrameStart();
int AftSoundRenderTo(int nPos);
int AftSoundFrameStop();

// Galaxy Force ----------------------------------
extern unsigned char GalGame;
extern unsigned char GalButton[8];
#define GAL_ANALOG_COUNT (6)
extern unsigned char GalAnalog[GAL_ANALOG_COUNT];
extern unsigned char bGalGear;
extern unsigned char GalDip[2];
extern unsigned char GalReset;
int GalFrame();
int GalInit();
int GalExit();
int GalScan(int nAction,int *pnMin);

// gal_line.cpp
extern unsigned char *GalLineSrc; // Original line sprite table
extern unsigned char *GalLineData; // Line Sprite bitmap data
extern int nGalLineDataLen; // Length of above
int GalLineDrawSprite(int i,unsigned char *ps);
int GalLineDraw();

// gal_spr.cpp
extern unsigned char *GalSprSrc; // Original sprite table
extern unsigned char *GalSprData; // Normal Sprite bitmap data
extern int nGalSprDataLen; // Length of above
int GalSprDraw();

